## kf6-kwallet 6.18.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

set(KF_VERSION "6.18.0") # handled by release scripts
set(KF_DEP_VERSION "6.18.0") # handled by release scripts
project(KWallet VERSION ${KF_VERSION})
set(CMAKE_EXPORT_COMPILE_COMMANDS 1)

include(FeatureSummary)
find_package(ECM 6.18.0  NO_MODULE)
set_package_properties(ECM PROPERTIES TYPE REQUIRED DESCRIPTION "Extra CMake Modules." URL "https://invent.kde.org/frameworks/extra-cmake-modules")
feature_summary(WHAT REQUIRED_PACKAGES_NOT_FOUND FATAL_ON_MISSING_REQUIRED_PACKAGES)

set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

include(KDEInstallDirs)
include(KDEFrameworkCompilerSettings NO_POLICY_SCOPE)
include(KDECMakeSettings)

include(KDEGitCommitHooks)
include(ECMDeprecationSettings)

set(REQUIRED_QT_VERSION 6.7.0)
find_package(Qt6 ${REQUIRED_QT_VERSION} CONFIG REQUIRED Core DBus Gui Widgets)

include(ECMGenerateExportHeader)
include(ECMSetupVersion)
include(ECMQtDeclareLoggingCategory)
include(ECMMarkNonGuiExecutable)
include(ECMGenerateQDoc)

option(BUILD_KSECRETD "Build the ksecretd daemon" ON)
if(NOT WIN32 AND NOT APPLE)
    option(BUILD_KWALLETD "Build the kwallet daemon" ON)
else()
    set(BUILD_KWALLETD OFF)
endif()
option(BUILD_KWALLET_QUERY "Build kwallet-query tool" ON)

if(NOT WIN32 AND NOT APPLE AND NOT HAIKU)
    option(WITH_X11 "Build with support for KWindowSystem::isPlatformX11()" ON)
endif()

# ksecretd contains functions that are marked as deprecated.
# These are part of the public DBus API and are used by older applications
# Therefore we must not exclude those by default
set(EXCLUDE_DEPRECATED_BEFORE_AND_AT 0 CACHE STRING "Control the range of deprecated API excluded from the build [default=0].")

find_package(KF6Config ${KF_DEP_VERSION} REQUIRED)

if(BUILD_KSECRETD OR BUILD_KWALLETD)
    find_package(KF6 ${KF_DEP_VERSION} REQUIRED COMPONENTS CoreAddons I18n WindowSystem)
endif()

ecm_set_disabled_deprecation_versions(
    QT 6.10.0
    KF 6.17.0
)

if (WIN32)
    set(EXPORT_LEGACY_API 1)
else()
    set(EXPORT_LEGACY_API 0)
endif()

add_definitions(-DTRANSLATION_DOMAIN=\"ksecretd6\")
if(BUILD_KSECRETD OR BUILD_KWALLETD OR BUILD_KWALLET_QUERY)
    ki18n_install(po)
endif()
add_subdirectory(src)
if (BUILD_TESTING)
    add_subdirectory(autotests)
    add_subdirectory(tests)
    add_subdirectory(examples)
endif()
if(BUILD_KWALLET_QUERY)
    find_package(KF6DocTools ${KF_DEP_VERSION})
    if(KF6DocTools_FOUND)
        add_subdirectory(docs)
    endif()
endif()

include(ECMFeatureSummary)
ecm_feature_summary(WHAT ALL   FATAL_ON_MISSING_REQUIRED_PACKAGES)

kde_configure_git_pre_commit_hook(CHECKS CLANG_FORMAT)

=== docs/CMakeLists.txt ===
add_subdirectory(kwallet-query)

=== src/CMakeLists.txt ===

add_subdirectory(api)
add_subdirectory(runtime)

ecm_qt_install_logging_categories(
    EXPORT KWALLET
    FILE kwallet.categories
    DESTINATION ${KDE_INSTALL_LOGGINGCATEGORIESDIR}
)

=== tests/CMakeLists.txt ===

add_subdirectory(KWallet)

if(BUILD_KSECRETD)
    add_subdirectory(kwalletd)
endif()

=== src/runtime/CMakeLists.txt ===
if(BUILD_KSECRETD OR BUILD_KWALLETD)
    find_package(Gpgmepp 1.7.0) # provided by GpgME

    if (Gpgmepp_FOUND)
        message("GPG support enabled")
        add_definitions(-DHAVE_GPGMEPP)
        add_definitions(-DBOOST_NO_EXCEPTIONS)
        include_directories(${GPGME_INCLUDES})
    endif(Gpgmepp_FOUND)
    add_subdirectory(kwalletbackend)
endif()

if(BUILD_KSECRETD)
    add_subdirectory(ksecretd)
endif()

if(BUILD_KWALLETD)
    add_subdirectory(kwalletd)
endif()

if(BUILD_KWALLET_QUERY)
  add_subdirectory(kwallet-query)
endif()

=== tests/kwalletd/CMakeLists.txt ===
include_directories( ${CMAKE_CURRENT_SOURCE_DIR}/../../src/api/KWallet ) # for kwallet.h
include_directories( ${CMAKE_CURRENT_BINARY_DIR}/../../src/api/KWallet )

include_directories( ${CMAKE_CURRENT_SOURCE_DIR}/../../src/runtime/ksecretd ) # kwalletwizard.h
include_directories( ${CMAKE_CURRENT_BINARY_DIR}/../../src/runtime/kwalletbackend ) # kwalletwizard.h

include(ECMMarkAsTest)

find_package(Qt6 ${REQUIRED_QT_VERSION} CONFIG REQUIRED Test)
find_package(KF6CoreAddons ${KF_DEP_VERSION} REQUIRED)
find_package(KF6I18n ${KF_DEP_VERSION} REQUIRED)
find_package(KF6WidgetsAddons ${KF_DEP_VERSION} REQUIRED)
find_package(Gpgmepp) # provided by GpgME

remove_definitions(-DQT_NO_CAST_FROM_ASCII)
remove_definitions(-DQT_NO_CAST_FROM_BYTEARRAY)

add_executable(kwalletwizardtest)
set(kwalletwizardtest_ui_SRCS)
qt_wrap_ui(kwalletwizardtest_ui_SRCS
   ../../src/runtime/ksecretd/kbetterthankdialogbase.ui
   ../../src/runtime/ksecretd/kwalletwizardpageexplanation.ui
   ../../src/runtime/ksecretd/kwalletwizardpageintro.ui
   ../../src/runtime/ksecretd/kwalletwizardpageoptions.ui
   ../../src/runtime/ksecretd/kwalletwizardpagepassword.ui
   ../../src/runtime/ksecretd/kwalletwizardpagegpgkey.ui
)

if (Gpgmepp_FOUND)
    qt_wrap_ui(kwalletwizardtest_ui_SRCS
        ../../src/runtime/ksecretd/kwalletwizardpagepasswordgpg.ui)
endif(Gpgmepp_FOUND)

target_sources(kwalletwizardtest PRIVATE
   kwalletwizardtest.cpp
   ../../src/runtime/ksecretd/kwalletwizard.cpp
   ${kwalletwizardtest_ui_SRCS}
)
ecm_mark_as_test(kwalletwizardtest)
target_link_libraries(kwalletwizardtest
    KF6Wallet
    Qt6::Test
    KF6::CoreAddons
    KF6::I18n
    KF6::WidgetsAddons)
if (Gpgmepp_FOUND)
    target_link_libraries(kwalletwizardtest Gpgmepp)
endif(Gpgmepp_FOUND)

add_library(kwallettestlib STATIC kwallettest.cpp)
target_link_libraries(kwallettestlib KF6Wallet Qt6::Widgets)

macro(ksecretd_tests)
  foreach(_testname ${ARGN})
    add_executable(${_testname} ${_testname}.cpp)
    ecm_mark_as_test(${_testname})
    target_link_libraries(${_testname}
        kwallettestlib
        KF6WalletBackend
        KF6Wallet
        Qt6::DBus
        Qt6::Test
        KF6::CoreAddons
        KF6::I18n)
  endforeach(_testname)
endmacro()

ksecretd_tests(
    kwalletasync
    kwalletsync
    kwalletpath
    kwalletboth
    kwalletmany
    kwalletcbc
)

=== src/api/KWallet/CMakeLists.txt ===

include(ECMGenerateHeaders)

ecm_setup_version(${KF_VERSION} VARIABLE_PREFIX KWALLET
                        VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/kwallet_version.h"
                        PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/KF6WalletConfigVersion.cmake"
                        SOVERSION 6)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/kwallet_version.h
        DESTINATION ${KDE_INSTALL_INCLUDEDIR_KF}/KWallet COMPONENT Devel
)

if(APPLE)
    option(MAC_USE_OSXKEYCHAIN "On OS X, use the keychain as backend for kwallet, instead of kwalletd.")
else()
    set(MAC_USE_OSXKEYCHAIN FALSE)
endif()

add_library(KF6Wallet)
add_library(KF6::Wallet ALIAS KF6Wallet)

set_target_properties(KF6Wallet PROPERTIES
    VERSION     ${KWALLET_VERSION}
    SOVERSION   ${KWALLET_SOVERSION}
    EXPORT_NAME Wallet
)

if (MAC_USE_OSXKEYCHAIN)
    find_library(COREFOUNDATION_LIBRARY CoreFoundation)
    find_library(SECURITY_LIBRARY Security)
    target_sources(KF6Wallet PRIVATE
        kwallet_mac.cpp
    )
else()
    set(kwallet_dbus_SRCS)
    if (NOT EXCLUDE_DEPRECATED_BEFORE_AND_AT STREQUAL "CURRENT" AND
        EXCLUDE_DEPRECATED_BEFORE_AND_AT VERSION_LESS 5.72.0)
        set(kwallet_xml org.kde.KWallet.xml)
    else()
        # copy of org.kde.KWallet.xml, but with all deprecated API removed
        set(kwallet_xml org.kde.nodeprecated.KWallet.xml)
    endif()
    qt_add_dbus_interface(kwallet_dbus_SRCS ${kwallet_xml} kwallet_interface)
    target_sources(KF6Wallet PRIVATE
        kwallet.cpp
        ${kwallet_dbus_SRCS}
    )
endif()

ecm_qt_declare_logging_category(KF6Wallet
    HEADER kwallet_api_debug.h
    IDENTIFIER KWALLET_API_LOG
    CATEGORY_NAME kf.wallet.api
    OLD_CATEGORY_NAMES kf5.kwallet.api
    DESCRIPTION "kwallet api"
    EXPORT KWALLET
)

ecm_generate_export_header(KF6Wallet
    BASE_NAME KWallet
    GROUP_BASE_NAME KF
    VERSION ${KF_VERSION}
    USE_VERSION_HEADER
    DEPRECATED_BASE_VERSION 0
    DEPRECATION_VERSIONS 5.72
    EXCLUDE_DEPRECATED_BEFORE_AND_AT ${EXCLUDE_DEPRECATED_BEFORE_AND_AT}
)

target_include_directories(KF6Wallet INTERFACE "$<INSTALL_INTERFACE:${KDE_INSTALL_INCLUDEDIR_KF}/KWallet>")

target_link_libraries(KF6Wallet
    PUBLIC
        Qt6::Gui
    PRIVATE
        Qt6::DBus
        Qt6::Widgets
        KF6::ConfigCore   # used to store the wallet to be used
)

if(MAC_USE_OSXKEYCHAIN)
   target_link_libraries(KF6Wallet PRIVATE ${CARBON_LIBRARY}
                                           ${SECURITY_LIBRARY}
                                           ${COREFOUNDATION_LIBRARY})
elseif(APPLE)
    target_link_libraries(KF6Wallet PRIVATE ${CARBON_LIBRARY})
else()
    target_link_libraries(KF6Wallet PRIVATE Qt6::DBus)
    install(FILES ${kwallet_xml} DESTINATION ${KDE_INSTALL_DBUSINTERFACEDIR} RENAME kf6_org.kde.KWallet.xml)
endif()

ecm_generate_headers(KWallet_HEADERS
  HEADER_NAMES
  KWallet

  REQUIRED_HEADERS KWallet_HEADERS
)

ecm_generate_qdoc(KF6Wallet kwallet.qdocconf)

install(TARGETS KF6Wallet EXPORT KF6WalletTargets ${KF_INSTALL_TARGETS_DEFAULT_ARGS})
install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/kwallet_export.h
  ${KWallet_HEADERS}
  DESTINATION ${KDE_INSTALL_INCLUDEDIR_KF}/KWallet COMPONENT Devel
)

# create a Config.cmake and a ConfigVersion.cmake file and install them
set(CMAKECONFIG_INSTALL_DIR "${KDE_INSTALL_CMAKEPACKAGEDIR}/KF6Wallet")

include(CMakePackageConfigHelpers)

configure_package_config_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/KF6WalletConfig.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/KF6WalletConfig.cmake"
  PATH_VARS KDE_INSTALL_DBUSINTERFACEDIR
  PATH_VARS KDE_INSTALL_BINDIR
  INSTALL_DESTINATION  ${CMAKECONFIG_INSTALL_DIR}
)

install(FILES
  "${CMAKE_CURRENT_BINARY_DIR}/KF6WalletConfig.cmake"
  "${CMAKE_CURRENT_BINARY_DIR}/KF6WalletConfigVersion.cmake"
  DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
  COMPONENT Devel
)

install(EXPORT KF6WalletTargets DESTINATION "${CMAKECONFIG_INSTALL_DIR}" FILE KF6WalletTargets.cmake NAMESPACE KF6:: )

=== src/runtime/ksecretd/CMakeLists.txt ===
configure_file(config-ksecretd.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-ksecretd.h )

include(CheckSymbolExists)

check_symbol_exists(explicit_bzero "string.h" KSECRETD_HAVE_EXPLICIT_BZERO)
if (NOT KSECRETD_HAVE_EXPLICIT_BZERO)
# On FreeBSD it's in strings.h
check_symbol_exists(explicit_bzero "strings.h" KSECRETD_HAVE_EXPLICIT_BZERO)
endif(NOT KSECRETD_HAVE_EXPLICIT_BZERO)
check_symbol_exists(RtlSecureZeroMemory "windows.h" KSECRETD_HAVE_RTLSECUREZEROMEMORY)

find_package(Qt6 ${REQUIRED_QT_VERSION} CONFIG REQUIRED Gui)

find_package(KF6ColorScheme ${KF_DEP_VERSION} REQUIRED)
find_package(KF6Config ${KF_DEP_VERSION} REQUIRED)
find_package(KF6CoreAddons ${KF_DEP_VERSION} REQUIRED)
find_package(KF6DBusAddons ${KF_DEP_VERSION} REQUIRED)
find_package(KF6Notifications ${KF_DEP_VERSION} REQUIRED)
find_package(KF6WidgetsAddons ${KF_DEP_VERSION} REQUIRED)
find_package(KF6WindowSystem ${KF_DEP_VERSION} REQUIRED)
find_package(KF6Crash ${KF_DEP_VERSION} REQUIRED)

########### find needed packages ######

find_package(Qca-qt6 REQUIRED 2.3.1)

include_directories(${CMAKE_CURRENT_BINARY_DIR})
########### build tests #########
add_subdirectory(autotests)

########### ksecretd ###############

add_executable(ksecretd)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../kwalletbackend)
include_directories(${CMAKE_CURRENT_BINARY_DIR}/../kwalletbackend)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../../api/KWallet)
include_directories(${CMAKE_CURRENT_BINARY_DIR}/../../api/KWallet)

remove_definitions(-DQT_NO_CAST_FROM_ASCII)

ecm_setup_version(${KF_VERSION} VARIABLE_PREFIX KSECRETD
                        VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/ksecretd_version.h"
                        PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/KF6WalletConfigVersion.cmake"
                        SOVERSION 6)

target_sources(ksecretd PRIVATE
   main.cpp
   kbetterthankdialog.cpp
   ksecretd.cpp
   kwalletwizard.cpp
   ktimeout.cpp
   kwalletsessionstore.cpp
   kwalletfreedesktopservice.cpp
   kwalletfreedesktopsession.cpp
   kwalletfreedesktopcollection.cpp
   kwalletfreedesktopitem.cpp
   kwalletfreedesktopprompt.cpp
   kwalletfreedesktopattributes.cpp

   kwalletportalsecrets.cpp
)
ecm_qt_declare_logging_category(ksecretd
    HEADER ksecretd_debug.h
    IDENTIFIER KSECRETD_LOG
    CATEGORY_NAME kf.wallet.ksecretd
    OLD_CATEGORY_NAMES kf5.kwallet.ksecretd
    DESCRIPTION "ksecretd"
    EXPORT KWALLET
)

ki18n_wrap_ui(ksecretd
   kbetterthankdialogbase.ui
   kwalletwizardpageexplanation.ui
   kwalletwizardpageintro.ui
   kwalletwizardpageoptions.ui
   kwalletwizardpagepassword.ui
)

if (Gpgmepp_FOUND)
    target_sources(ksecretd PRIVATE
        knewwalletdialog.cpp
    )
    ki18n_wrap_ui(ksecretd
        kwalletwizardpagepasswordgpg.ui
        kwalletwizardpagegpgkey.ui
        knewwalletdialogintro.ui
        knewwalletdialoggpg.ui
    )
endif(Gpgmepp_FOUND)

if (NOT EXCLUDE_DEPRECATED_BEFORE_AND_AT STREQUAL "CURRENT" AND
    EXCLUDE_DEPRECATED_BEFORE_AND_AT VERSION_LESS 5.72.0)
    set(kwallet_xml ${CMAKE_SOURCE_DIR}/src/api/KWallet/org.kde.KWallet.xml)
else()
    # copy of org.kde.KWallet.xml, but with all deprecated API removed
    set(kwallet_xml ${CMAKE_SOURCE_DIR}/src/api/KWallet/org.kde.nodeprecated.KWallet.xml)
endif()
set(fdo_service_xml ${CMAKE_SOURCE_DIR}/src/api/KWallet/org.freedesktop.Secrets.Service.xml)
set(fdo_session_xml ${CMAKE_SOURCE_DIR}/src/api/KWallet/org.freedesktop.Secrets.Session.xml)
set(fdo_collection_xml ${CMAKE_SOURCE_DIR}/src/api/KWallet/org.freedesktop.Secrets.Collection.xml)
set(fdo_item_xml ${CMAKE_SOURCE_DIR}/src/api/KWallet/org.freedesktop.Secrets.Item.xml)
set(fdo_prompt_xml ${CMAKE_SOURCE_DIR}/src/api/KWallet/org.freedesktop.Secrets.Prompt.xml)
set(fdo_portal_secret_xml ${CMAKE_SOURCE_DIR}/src/api/KWallet/org.freedesktop.impl.portal.Secret.xml)

set(ksecretd_dbus_SRCS)
qt_add_dbus_adaptor(ksecretd_dbus_SRCS ${kwallet_xml} ksecretd.h KSecretD kwalletadaptor KWalletAdaptor)
qt_add_dbus_adaptor(ksecretd_dbus_SRCS ${fdo_service_xml} kwalletfreedesktopservice.h KWalletFreedesktopService
    kwalletfreedesktopserviceadaptor KWalletFreedesktopServiceAdaptor)
qt_add_dbus_adaptor(ksecretd_dbus_SRCS ${fdo_session_xml} kwalletfreedesktopsession.h KWalletFreedesktopSession
    kwalletfreedesktopsessionadaptor KWalletFreedesktopSessionAdaptor)
qt_add_dbus_adaptor(ksecretd_dbus_SRCS ${fdo_collection_xml} kwalletfreedesktopcollection.h KWalletFreedesktopCollection
    kwalletfreedesktopcollectionadaptor KWalletFreedesktopCollectionAdaptor)
qt_add_dbus_adaptor(ksecretd_dbus_SRCS ${fdo_item_xml} kwalletfreedesktopitem.h KWalletFreedesktopItem
    kwalletfreedesktopitemadaptor KWalletFreedesktopItemAdaptor)
qt_add_dbus_adaptor(ksecretd_dbus_SRCS ${fdo_prompt_xml} kwalletfreedesktopprompt.h KWalletFreedesktopPrompt
    kwalletfreedesktoppromptadaptor KWalletFreedesktopPromptAdaptor)
qt_add_dbus_adaptor(ksecretd_dbus_SRCS ${fdo_portal_secret_xml} kwalletportalsecrets.h KWalletPortalSecrets
    kwalletportalsecretsadaptor KWalletPortalSecretsAdaptor)

target_sources(ksecretd PRIVATE
    ${ksecretd_dbus_SRCS}
)

if (HAIKU)
    target_link_libraries(ksecretd network)
endif ()

target_link_libraries(ksecretd
    KF6WalletBackend
    KF6Wallet
    Qt6::Widgets
    KF6::I18n
    KF6::ColorScheme
    KF6::CoreAddons
    KF6::ConfigCore
    KF6::DBusAddons
    KF6::WidgetsAddons
    KF6::WindowSystem
    KF6::Notifications
    KF6::Crash
    ${Qca_LIBRARY})
if (Gpgmepp_FOUND)
    target_link_libraries(ksecretd Gpgmepp)
    kde_target_enable_exceptions(ksecretd PRIVATE)
endif(Gpgmepp_FOUND)

ecm_mark_nongui_executable(ksecretd)
install(TARGETS ksecretd  ${KF_INSTALL_TARGETS_DEFAULT_ARGS})

if(WIN32)
    configure_file(org.kde.kwalletd5.service.win.in
                   ${CMAKE_CURRENT_BINARY_DIR}/org.kde.kwalletd5.service)
    configure_file(org.kde.kwalletd6.service.win.in
                   ${CMAKE_CURRENT_BINARY_DIR}/org.kde.kwalletd6.service)
    install(
        FILES
            ${CMAKE_CURRENT_BINARY_DIR}/org.kde.kwalletd5.service
            ${CMAKE_CURRENT_BINARY_DIR}/org.kde.kwalletd6.service
        DESTINATION ${KDE_INSTALL_DBUSSERVICEDIR}
    )
else()
    configure_file(org.kde.secretservicecompat.service.in
                   ${CMAKE_CURRENT_BINARY_DIR}/org.kde.secretservicecompat.service)
    configure_file(org.freedesktop.impl.portal.desktop.kwallet.service.in
                   ${CMAKE_CURRENT_BINARY_DIR}/org.freedesktop.impl.portal.desktop.kwallet.service)

    install(
        FILES
            ${CMAKE_CURRENT_BINARY_DIR}/org.kde.secretservicecompat.service
            ${CMAKE_CURRENT_BINARY_DIR}/org.freedesktop.impl.portal.desktop.kwallet.service
        DESTINATION ${KDE_INSTALL_DBUSSERVICEDIR}
    )
endif()

########### install files ###############
install( FILES ksecretd.notifyrc DESTINATION  ${KDE_INSTALL_KNOTIFYRCDIR} )
install( FILES org.kde.ksecretd.desktop DESTINATION ${KDE_INSTALL_APPDIR} )
install( FILES kwallet.portal DESTINATION ${KDE_INSTALL_DATADIR}/xdg-desktop-portal/portals)

=== src/runtime/kwalletbackend/CMakeLists.txt ===
include(CheckIncludeFiles)
include(GenerateExportHeader)

########### Configure checks for kwalletbackend ###############

check_include_files(stdint.h HAVE_STDINT_H)
check_include_files(sys/bitypes.h HAVE_SYS_BITYPES_H)
if (Gpgmepp_FOUND)
    add_definitions(-DHAVE_GPGMEPP)
    add_definitions(-DBOOST_NO_EXCEPTIONS)
endif(Gpgmepp_FOUND)

configure_file (config-kwalletbackend.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-kwalletbackend.h )

########### kwalletbackend ###############
find_package(Qt6 ${REQUIRED_QT_VERSION} CONFIG REQUIRED Widgets DBus)
find_package(KF6CoreAddons ${KF_DEP_VERSION} REQUIRED)
find_package(KF6I18n ${KF_DEP_VERSION} REQUIRED)
find_package(KF6Notifications ${KF_DEP_VERSION} REQUIRED)
find_package(KF6WidgetsAddons ${KF_DEP_VERSION} REQUIRED)
find_package(KF6Config ${KF_DEP_VERSION} REQUIRED)

find_package(LibGcrypt 1.5.0 REQUIRED)
set_package_properties(LibGcrypt PROPERTIES
                       TYPE REQUIRED
                       PURPOSE "kwalletd needs libgcrypt to perform PBKDF2-SHA512 hashing"
                      )
find_package(Qca-qt6 REQUIRED 2.3.1)

ecm_setup_version(${KF_VERSION} VARIABLE_PREFIX KWALLETBACKEND SOVERSION 6)

add_library(KF6WalletBackend SHARED)

set_target_properties(KF6WalletBackend PROPERTIES
    VERSION   ${KWALLETBACKEND_VERSION}
    SOVERSION ${KWALLETBACKEND_SOVERSION}
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../../api/KWallet)
include_directories(${CMAKE_CURRENT_BINARY_DIR}/../../api/KWallet)
include_directories(${LIBGCRYPT_INCLUDE_DIRS})

remove_definitions(-DQT_NO_CAST_FROM_ASCII)

target_sources(KF6WalletBackend PRIVATE
   blockcipher.cc
   blowfish.cc
   cbc.cc
   sha1.cc
   kwalletentry.cc
   kwalletbackend.cc
   backendpersisthandler.cpp
)
ecm_qt_declare_logging_category(KF6WalletBackend
    HEADER kwalletbackend_debug.h
    IDENTIFIER KWALLETBACKEND_LOG
    CATEGORY_NAME kf.wallet.backend
    OLD_CATEGORY_NAMES kf5.kwallet.kwalletbackend
    DESCRIPTION "kwalletbackend"
    EXPORT KWALLET
)


generate_export_header(KF6WalletBackend
    BASE_NAME kwalletbackend
)

target_link_libraries(KF6WalletBackend
    Qt6::Widgets
    KF6::WidgetsAddons
    KF6::CoreAddons
    KF6::Notifications
    KF6::I18n
    ${LIBGCRYPT_LIBRARIES}
    ${Qca_LIBRARY}
)
if(Gpgmepp_FOUND)
   target_link_libraries(KF6WalletBackend Gpgmepp)
endif(Gpgmepp_FOUND)

# link with advapi32 on windows
if(WIN32 AND NOT WINCE)
   target_link_libraries(KF6WalletBackend advapi32)
endif(WIN32 AND NOT WINCE)

install(TARGETS KF6WalletBackend ${KF_INSTALL_TARGETS_DEFAULT_ARGS} LIBRARY NAMELINK_SKIP)

add_subdirectory(tests)

=== src/runtime/kwalletd/CMakeLists.txt ===

find_package(KF6WidgetsAddons ${KF_DEP_VERSION} REQUIRED)
find_package(KF6DBusAddons ${KF_DEP_VERSION} REQUIRED)
find_package(PkgConfig REQUIRED)

pkg_check_modules(LIBSECRET REQUIRED libsecret-1)
include_directories(${LIBSECRET_INCLUDE_DIRS})
link_directories(${LIBSECRET_LIBRARY_DIRS})
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../kwalletbackend)
include_directories(${CMAKE_CURRENT_BINARY_DIR}/../kwalletbackend)


if(NOT WIN32)
    configure_file(org.kde.kwalletd5.service.in
                   ${CMAKE_CURRENT_BINARY_DIR}/org.kde.kwalletd5.service)
    configure_file(org.kde.kwalletd6.service.in
                   ${CMAKE_CURRENT_BINARY_DIR}/org.kde.kwalletd6.service)
endif()

install(
    FILES
        ${CMAKE_CURRENT_BINARY_DIR}/org.kde.kwalletd5.service
        ${CMAKE_CURRENT_BINARY_DIR}/org.kde.kwalletd6.service
    DESTINATION ${KDE_INSTALL_DBUSSERVICEDIR}
)

set(kwalletd6_SRCS
    main.cpp
    kwalletd.cpp
    secretserviceclient.cpp
)

add_executable(kwalletd6)

if (NOT EXCLUDE_DEPRECATED_BEFORE_AND_AT STREQUAL "CURRENT" AND
    EXCLUDE_DEPRECATED_BEFORE_AND_AT VERSION_LESS 5.72.0)
    set(kwallet_xml ${CMAKE_SOURCE_DIR}/src/api/KWallet/org.kde.KWallet.xml)
else()
    # copy of org.kde.KWallet.xml, but with all deprecated API removed
    set(kwallet_xml ${CMAKE_SOURCE_DIR}/src/api/KWallet/org.kde.nodeprecated.KWallet.xml)
endif()

qt_add_dbus_adaptor(kwalletd6_SRCS
    ${kwallet_xml}
    kwalletd.h KWalletD
)

target_sources(kwalletd6 PRIVATE
    ${kwalletd6_SRCS}
)

ecm_qt_declare_logging_category(kwalletd6
    HEADER kwalletd_debug.h
    IDENTIFIER KWALLETD_LOG
    CATEGORY_NAME kf.wallet.kwalletd
    DESCRIPTION "kwalletd"
    EXPORT KWALLET
)

target_link_libraries(kwalletd6
    KF6WalletBackend
    KF6::ConfigCore
    KF6::CoreAddons
    KF6::WidgetsAddons
    #KF6::Crash
    KF6::I18n
    KF6::DBusAddons
    KF6::Wallet
    Qt6::Widgets
    Qt::DBus
    ${LIBSECRET_LIBRARIES}
)

install( TARGETS kwalletd6 ${KDE_INSTALL_TARGETS_DEFAULT_ARGS} )

=== src/runtime/ksecretd/autotests/CMakeLists.txt ===
set( EXECUTABLE_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR} )

find_package(Qt6Test REQUIRED)
find_package(KF6Config ${KF6_DEP_VERSION} REQUIRED)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)

include(ECMAddTests)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/..)
include_directories(${CMAKE_CURRENT_BINARY_DIR}/..)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../../../api/KWallet)
include_directories(${CMAKE_CURRENT_BINARY_DIR}/../../../api/KWallet)

add_definitions(-DFDO_ENABLE_DUMMY_MESSAGE_CONNECTION)
remove_definitions(-DQT_NO_CAST_FROM_ASCII)

if (NOT EXCLUDE_DEPRECATED_BEFORE_AND_AT STREQUAL "CURRENT" AND
    EXCLUDE_DEPRECATED_BEFORE_AND_AT VERSION_LESS 5.72.0)
    set(kwallet_xml ${CMAKE_SOURCE_DIR}/src/api/KWallet/org.kde.KWallet.xml)
else()
    # copy of org.kde.KWallet.xml, but with all deprecated API removed
    set(kwallet_xml ${CMAKE_SOURCE_DIR}/src/api/KWallet/org.kde.nodeprecated.KWallet.xml)
endif()
set(fdo_service_xml ${CMAKE_SOURCE_DIR}/src/api/KWallet/org.freedesktop.Secrets.Service.xml)
set(fdo_session_xml ${CMAKE_SOURCE_DIR}/src/api/KWallet/org.freedesktop.Secrets.Session.xml)
set(fdo_collection_xml ${CMAKE_SOURCE_DIR}/src/api/KWallet/org.freedesktop.Secrets.Collection.xml)
set(fdo_item_xml ${CMAKE_SOURCE_DIR}/src/api/KWallet/org.freedesktop.Secrets.Item.xml)
set(fdo_prompt_xml ${CMAKE_SOURCE_DIR}/src/api/KWallet/org.freedesktop.Secrets.Prompt.xml)

set(TEST_SRC
    fdo_secrets_test.cpp
    ../kwalletfreedesktopservice.cpp
    ../kwalletfreedesktopitem.cpp
    ../kwalletfreedesktopcollection.cpp
    ../kwalletfreedesktopsession.cpp
    ../kwalletfreedesktopprompt.cpp
    ../kwalletfreedesktopattributes.cpp
)

qt_add_dbus_adaptor( TEST_SRC ${kwallet_xml} ../ksecretd.h KSecretD kwalletadaptor KWalletAdaptor)
qt_add_dbus_adaptor( TEST_SRC ${fdo_service_xml} ../kwalletfreedesktopservice.h KWalletFreedesktopService
    kwalletfreedesktopserviceadaptor KWalletFreedesktopServiceAdaptor)
qt_add_dbus_adaptor( TEST_SRC ${fdo_session_xml} ../kwalletfreedesktopsession.h KWalletFreedesktopSession
    kwalletfreedesktopsessionadaptor KWalletFreedesktopSessionAdaptor)
qt_add_dbus_adaptor( TEST_SRC ${fdo_collection_xml} ../kwalletfreedesktopcollection.h KWalletFreedesktopCollection
    kwalletfreedesktopcollectionadaptor KWalletFreedesktopCollectionAdaptor)
qt_add_dbus_adaptor( TEST_SRC ${fdo_item_xml} ../kwalletfreedesktopitem.h KWalletFreedesktopItem
    kwalletfreedesktopitemadaptor KWalletFreedesktopItemAdaptor)
qt_add_dbus_adaptor( TEST_SRC ${fdo_prompt_xml} ../kwalletfreedesktopprompt.h KWalletFreedesktopPrompt
    kwalletfreedesktoppromptadaptor KWalletFreedesktopPromptAdaptor)

ecm_add_test(
    ${TEST_SRC}
    ../kwalletfreedesktopservice.h
    ../kwalletfreedesktopcollection.h
    ../kwalletfreedesktopitem.h
    ../kwalletfreedesktopsession.h
    ../kwalletfreedesktopprompt.h
    ../ksecretd.h
    ../ktimeout.h
    kwalletfreedesktopserviceadaptor.cpp
    kwalletfreedesktopcollectionadaptor.cpp
    kwalletfreedesktopitemadaptor.cpp
    kwalletfreedesktopsessionadaptor.cpp
    kwalletfreedesktoppromptadaptor.cpp
    TEST_NAME fdo_secrets_test
    LINK_LIBRARIES
        KF6Wallet
        KF6WalletBackend
        Qt6::Widgets
        Qt6::Test
        KF6::DBusAddons
        KF6::ConfigCore
        ${Qca_LIBRARY}
)

=== debian/changelog ===
kf6-kwallet (6.18.0-2) unstable; urgency=medium

  [ Patrick Franz ]
  * Ensure that older versions of kwallet-pam cannot be used with
    kf6-kwallet 6.18.0 or newer as kwallet-pam now needs to launch
    ksecretd instead of kwalletd.

 -- Patrick Franz <deltaone@debian.org>  Thu, 02 Oct 2025 18:41:05 +0200

kf6-kwallet (6.18.0-1) unstable; urgency=medium

  [ Patrick Franz ]
  * New upstream release (6.18.0).
  * Update build-deps and deps with the info from cmake.
  * Refresh patches.
  * Update list of installed files.

 -- Patrick Franz <deltaone@debian.org>  Tue, 30 Sep 2025 19:18:06 +0200

=== debian/control ===
Source: kf6-kwallet
Section: libs
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Aurélien COUDERC <coucouf@debian.org>,
           Patrick Franz <deltaone@debian.org>,
Build-Depends: debhelper-compat (= 13),
               dh-sequence-kf6,
               dh-sequence-pkgkde-symbolshelper,
               cmake (>= 3.16~),
               doxygen,
               extra-cmake-modules (>= 6.18.0~),
               libgcrypt20-dev (>= 1.5.0~),
               libgpgme-dev | libgpgme11-dev,
               libgpgmepp-dev (>= 1.7.0~),
               libkf6colorscheme-dev (>= 6.18.0~),
               libkf6config-dev (>= 6.18.0~),
               libkf6coreaddons-dev (>= 6.18.0~),
               libkf6crash-dev (>= 6.18.0~),
               libkf6dbusaddons-dev (>= 6.18.0~),
               libkf6doctools-dev (>= 6.18.0~),
               libkf6i18n-dev (>= 6.18.0~),
               libkf6notifications-dev (>= 6.18.0~),
               libkf6widgetsaddons-dev (>= 6.18.0~),
               libkf6windowsystem-dev (>= 6.18.0~),
               libqca-qt6-dev (>= 2.3.1~),
               libqca-qt6-plugins <!nocheck>,
               libqt6sql6-sqlite <!nocheck>,
               libsecret-1-dev,
               libxkbcommon-dev,
               pkgconf,
               qt6-base-dev (>= 6.7.0~),
               qt6-declarative-dev (>= 6.5.0~),
Standards-Version: 4.7.2
Homepage: https://invent.kde.org/frameworks/kwallet
Vcs-Browser: https://salsa.debian.org/qt-kde-team/kde/kf6-kwallet
Vcs-Git: https://salsa.debian.org/qt-kde-team/kde/kf6-kwallet.git
Rules-Requires-Root: no

Package: kwallet6
Architecture: any
Multi-Arch: foreign
Depends: libkf6wallet-data (= ${source:Version}),
         libkf6walletbackend6 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Breaks: libkf5wallet-bin (<< 5.115.0-3~),
        libkf6wallet-bin,
        libpam-kwallet5 (<< 6.3.4-2~),
Replaces: libkf5wallet-bin (<< 5.115.0-3~),
          libkf6wallet-bin,
Description: safe desktop-wide storage for passwords - kwalletd daemon
 This framework contains two main components:
 - Interface to KWallet, the safe desktop-wide storage for
   passwords on KDE work spaces.
 - The kwalletd used to safely store the passwords on KDE work spaces.
 .
 This package contains the kwalletd runtime daemon.

Package: libkf6wallet-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
Description: safe desktop-wide storage for passwords - data files
 This framework contains two main components:
 - Interface to KWallet, the safe desktop-wide storage for
   passwords on KDE work spaces.
 - The kwalletd used to safely store the passwords on KDE work spaces.
 .
 This package contains the translation files for the KWallet framework.

Package: libkf6wallet-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libkf6colorscheme-dev (>= 6.18.0~),
         libkf6config-dev (>= 6.18.0~),
         libkf6coreaddons-dev (>= 6.18.0~),
         libkf6dbusaddons-dev (>= 6.18.0~),
         libkf6i18n-dev (>= 6.18.0~),
         libkf6notifications-dev (>= 6.18.0~),
         libkf6wallet6 (= ${binary:Version}),
         libkf6walletbackend6 (= ${binary:Version}),
         libkf6widgetsaddons-dev (>= 6.18.0~),
         libkf6windowsystem-dev (>= 6.18.0~),
         libqca-qt6-dev (>= 2.3.1~),
         qt6-base-dev (>= 6.7.0~),
         ${misc:Depends},
Recommends: libkf6wallet-doc (= ${source:Version}),
Description: safe desktop-wide storage for passwords - development files
 This framework contains two main components:
 - Interface to KWallet, the safe desktop-wide storage for
   passwords on KDE work spaces.
 - The kwalletd used to safely store the passwords on KDE work spaces.
 .
 This package contains the development files for the KWallet framework.

Package: libkf6wallet-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
Description: safe desktop-wide storage for passwords - developer documentation
 This framework contains two main components:
 - Interface to KWallet, the safe desktop-wide storage for
   passwords on KDE work spaces.
 - The kwalletd used to safely store the passwords on KDE work spaces.
 .
 This package contains the QCH developer documentation for the KWallet
 framework.

Package: libkf6wallet6
Architecture: any
Multi-Arch: same
Depends: libkf6wallet-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: safe desktop-wide storage for passwords - shared library
 This framework contains two main components:
 - Interface to KWallet, the safe desktop-wide storage for
   passwords on KDE work spaces.
 - The kwalletd used to safely store the passwords on KDE work spaces.
 .
 This package contains the shared library to interface with KWallet.

Package: libkf6walletbackend6
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: safe desktop-wide storage for passwords - backend library
 This framework contains two main components:
 - Interface to KWallet, the safe desktop-wide storage for
   passwords on KDE work spaces.
 - The kwalletd used to safely store the passwords on KDE work spaces.
 .
 This package contains the library with the password storage backend
 implementation for the kwalletd daemon.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=+lto

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_QCH=ON

override_dh_auto_test:
	# 1 - fdo_secrets_test (SEGFAULT)

## kf6-kwallet 6.18.0+p24.04+vstable+git20250909.0023

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.16)
 
-set(KF_VERSION "6.18.0") # handled by release scripts
+set(KF_VERSION "6.19.0") # handled by release scripts
 set(KF_DEP_VERSION "6.18.0") # handled by release scripts
 project(KWallet VERSION ${KF_VERSION})
 set(CMAKE_EXPORT_COMPILE_COMMANDS 1)

=== debian/changelog ===
kf6-kwallet (6.18.0+p24.04+vstable+git20250909.0023-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Tue, 09 Sep 2025 00:23:04 +0000

kf6-kwallet (6.18.0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Mon, 08 Sep 2025 23:08:47 +0000

kf6-kwallet (6.17.0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Sat, 09 Aug 2025 00:31:11 +0000

kf6-kwallet (6.16.0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Fri, 11 Jul 2025 06:46:10 +0000

kf6-kwallet (6.15.0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Mon, 16 Jun 2025 06:04:33 +0000

kf6-kwallet (6.14.1-0neon) noble; urgency=medium

  * New release

 -- Carlos De Maine <carlosd.kde@gmail.com>  Tue, 03 Jun 2025 08:48:25 +1000

kf6-kwallet (6.14.0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Wed, 07 May 2025 10:46:55 +0000

kf6-kwallet (6.13.0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Sun, 13 Apr 2025 02:12:57 +0000

kf6-kwallet (6.12.0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Mon, 17 Mar 2025 22:15:22 +0000

kf6-kwallet (6.11.0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 20 Feb 2025 03:39:50 +0000

kf6-kwallet (6.10.0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 09 Jan 2025 12:20:33 +0000

kf6-kwallet (6.9.0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Fri, 13 Dec 2024 10:40:57 +0000

kf6-kwallet (6.8.0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Sat, 09 Nov 2024 00:43:57 +0000

kf6-kwallet (6.7.0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Tue, 15 Oct 2024 15:37:48 +0000

kf6-kwallet (6.6.0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Sat, 21 Sep 2024 03:45:55 +0000

kf6-kwallet (6.5.0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Wed, 14 Aug 2024 12:52:52 +0000

kf6-kwallet (6.4.0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Mon, 15 Jul 2024 04:56:58 +0000

kf6-kwallet (6.3.0-1neon) noble; urgency=medium

  * new release

 -- Carlos De Maine <carlosdemaine@gmail.com>  Thu, 13 Jun 2024 14:34:14 +1000

kf6-kwallet (6.3.0-0neon) jammy; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Tue, 11 Jun 2024 04:04:30 +0000

kf6-kwallet (6.2.1-0neon) jammy; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Wed, 21 Feb 2024 16:28:10 +0000

kf6-kwallet (5.245.0-0neon) jammy; urgency=medium

  * New alpha release

 -- Neon CI <neon@kde.org>  Fri, 17 Nov 2023 01:18:08 +0000

kf6-kwallet (0.0-0neon) UNRELEASED; urgency=medium

  * New release

 -- Jonathan Esk-Riddell <jr@jriddell.org>  Mon, 12 Dec 2022 13:04:30 +0000

## kf6-kwallet 6.18.0+p24.04+vstable+git20250914.1320

=== CMakeLists.txt ===
--- 
+++ 
@@ -53,7 +53,7 @@
 
 ecm_set_disabled_deprecation_versions(
     QT 6.10.0
-    KF 6.17.0
+    KF 6.18.0
 )
 
 if (WIN32)

=== debian/changelog ===
kf6-kwallet (6.18.0+p24.04+vstable+git20250914.1320-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sun, 14 Sep 2025 13:20:01 +0000

## kf6-kwallet 6.18.0+p24.04+vstable+git20251006.0110

=== debian/changelog ===
kf6-kwallet (6.18.0+p24.04+vstable+git20251006.0110-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Mon, 06 Oct 2025 01:10:56 +0000

## kf6-kwallet 6.19.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,12 +1,12 @@
 cmake_minimum_required(VERSION 3.16)
 
 set(KF_VERSION "6.19.0") # handled by release scripts
-set(KF_DEP_VERSION "6.18.0") # handled by release scripts
+set(KF_DEP_VERSION "6.19.0") # handled by release scripts
 project(KWallet VERSION ${KF_VERSION})
 set(CMAKE_EXPORT_COMPILE_COMMANDS 1)
 
 include(FeatureSummary)
-find_package(ECM 6.18.0  NO_MODULE)
+find_package(ECM 6.19.0  NO_MODULE)
 set_package_properties(ECM PROPERTIES TYPE REQUIRED DESCRIPTION "Extra CMake Modules." URL "https://invent.kde.org/frameworks/extra-cmake-modules")
 feature_summary(WHAT REQUIRED_PACKAGES_NOT_FOUND FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== tests/KWallet/CMakeLists.txt ===
remove_definitions(-DQT_NO_CAST_FROM_ASCII)
remove_definitions(-DQT_NO_CAST_TO_ASCII)

include(ECMMarkAsTest)

find_package(Qt6 ${REQUIRED_QT_VERSION} CONFIG REQUIRED Test)

macro(kwallet_executable_tests)
  foreach(_testname ${ARGN})
    add_executable(${_testname} ${_testname}.cpp)
    ecm_mark_as_test(${_testname})
    target_link_libraries(${_testname} Qt6::Test Qt6::Widgets KF6::Wallet)
  endforeach(_testname)
endmacro()

kwallet_executable_tests(
  kwallettest
)

=== debian/changelog ===
kf6-kwallet (6.19.0-0ubuntu1) resolute; urgency=medium

  * New upstream release (6.18.0)
  * Update install files.
  * New upstream release (6.19.0)

 -- Rik Mills <rikmills@kde.org>  Sun, 12 Oct 2025 15:08:11 +0100

=== debian/control ===
--- 
+++ 
@@ -1,40 +1,41 @@
 Source: kf6-kwallet
 Section: libs
 Priority: optional
-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
+Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
 Uploaders: Aurélien COUDERC <coucouf@debian.org>,
            Patrick Franz <deltaone@debian.org>,
-Build-Depends: debhelper-compat (= 13),
+Build-Depends: cmake (>= 3.16~),
+               debhelper-compat (= 13),
                dh-sequence-kf6,
                dh-sequence-pkgkde-symbolshelper,
-               cmake (>= 3.16~),
                doxygen,
-               extra-cmake-modules (>= 6.18.0~),
+               extra-cmake-modules (>= 6.19.0~),
                libgcrypt20-dev (>= 1.5.0~),
                libgpgme-dev | libgpgme11-dev,
                libgpgmepp-dev (>= 1.7.0~),
-               libkf6colorscheme-dev (>= 6.18.0~),
-               libkf6config-dev (>= 6.18.0~),
-               libkf6coreaddons-dev (>= 6.18.0~),
-               libkf6crash-dev (>= 6.18.0~),
-               libkf6dbusaddons-dev (>= 6.18.0~),
-               libkf6doctools-dev (>= 6.18.0~),
-               libkf6i18n-dev (>= 6.18.0~),
-               libkf6notifications-dev (>= 6.18.0~),
-               libkf6widgetsaddons-dev (>= 6.18.0~),
-               libkf6windowsystem-dev (>= 6.18.0~),
+               libkf6colorscheme-dev (>= 6.19.0~),
+               libkf6config-dev (>= 6.19.0~),
+               libkf6coreaddons-dev (>= 6.19.0~),
+               libkf6crash-dev (>= 6.19.0~),
+               libkf6dbusaddons-dev (>= 6.19.0~),
+               libkf6doctools-dev (>= 6.19.0~),
+               libkf6i18n-dev (>= 6.19.0~),
+               libkf6notifications-dev (>= 6.19.0~),
+               libkf6widgetsaddons-dev (>= 6.19.0~),
+               libkf6windowsystem-dev (>= 6.19.0~),
                libqca-qt6-dev (>= 2.3.1~),
                libqca-qt6-plugins <!nocheck>,
                libqt6sql6-sqlite <!nocheck>,
                libsecret-1-dev,
                libxkbcommon-dev,
                pkgconf,
-               qt6-base-dev (>= 6.7.0~),
+               qt6-base-dev (>= 6.5.0~),
                qt6-declarative-dev (>= 6.5.0~),
-Standards-Version: 4.7.2
+Standards-Version: 4.7.0
 Homepage: https://invent.kde.org/frameworks/kwallet
-Vcs-Browser: https://salsa.debian.org/qt-kde-team/kde/kf6-kwallet
-Vcs-Git: https://salsa.debian.org/qt-kde-team/kde/kf6-kwallet.git
+Vcs-Browser: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kf6-kwallet
+Vcs-Git: https://git.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kf6-kwallet
 Rules-Requires-Root: no
 
 Package: kwallet6
@@ -44,11 +45,8 @@
          libkf6walletbackend6 (= ${binary:Version}),
          ${misc:Depends},
          ${shlibs:Depends},
-Breaks: libkf5wallet-bin (<< 5.115.0-3~),
-        libkf6wallet-bin,
-        libpam-kwallet5 (<< 6.3.4-2~),
-Replaces: libkf5wallet-bin (<< 5.115.0-3~),
-          libkf6wallet-bin,
+Breaks: libkf5wallet-bin (<< 5.115.0-3~), libkf6wallet-bin,
+Replaces: libkf5wallet-bin (<< 5.115.0-3~), libkf6wallet-bin,
 Description: safe desktop-wide storage for passwords - kwalletd daemon
  This framework contains two main components:
  - Interface to KWallet, the safe desktop-wide storage for
@@ -73,18 +71,18 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libkf6colorscheme-dev (>= 6.18.0~),
-         libkf6config-dev (>= 6.18.0~),
-         libkf6coreaddons-dev (>= 6.18.0~),
-         libkf6dbusaddons-dev (>= 6.18.0~),
-         libkf6i18n-dev (>= 6.18.0~),
-         libkf6notifications-dev (>= 6.18.0~),
+Depends: libkf6colorscheme-dev (>= 6.19.0~),
+         libkf6config-dev (>= 6.19.0~),
+         libkf6coreaddons-dev (>= 6.19.0~),
+         libkf6dbusaddons-dev (>= 6.19.0~),
+         libkf6i18n-dev (>= 6.19.0~),
+         libkf6notifications-dev (>= 6.19.0~),
          libkf6wallet6 (= ${binary:Version}),
          libkf6walletbackend6 (= ${binary:Version}),
-         libkf6widgetsaddons-dev (>= 6.18.0~),
-         libkf6windowsystem-dev (>= 6.18.0~),
+         libkf6widgetsaddons-dev (>= 6.19.0~),
+         libkf6windowsystem-dev (>= 6.19.0~),
          libqca-qt6-dev (>= 2.3.1~),
-         qt6-base-dev (>= 6.7.0~),
+         qt6-base-dev (>= 6.5.0~),
          ${misc:Depends},
 Recommends: libkf6wallet-doc (= ${source:Version}),
 Description: safe desktop-wide storage for passwords - development files
@@ -111,10 +109,10 @@
 
 Package: libkf6wallet6
 Architecture: any
-Multi-Arch: same
 Depends: libkf6wallet-data (= ${source:Version}),
          ${misc:Depends},
          ${shlibs:Depends},
+Multi-Arch: same
 Description: safe desktop-wide storage for passwords - shared library
  This framework contains two main components:
  - Interface to KWallet, the safe desktop-wide storage for
@@ -125,9 +123,8 @@
 
 Package: libkf6walletbackend6
 Architecture: any
+Depends: ${misc:Depends}, ${shlibs:Depends},
 Multi-Arch: same
-Depends: ${misc:Depends},
-         ${shlibs:Depends},
 Description: safe desktop-wide storage for passwords - backend library
  This framework contains two main components:
  - Interface to KWallet, the safe desktop-wide storage for

## kf6-kwallet 6.19.0+p24.04+vstable+git20251011.0959

=== debian/changelog ===
kf6-kwallet (6.19.0+p24.04+vstable+git20251011.0959-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sat, 11 Oct 2025 09:59:45 +0000

kf6-kwallet (6.19.0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Wed, 08 Oct 2025 07:10:53 +0000

## kf6-kwallet 6.19.0+p24.04+vstable+git20251015.1052

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.16)
 
-set(KF_VERSION "6.19.0") # handled by release scripts
+set(KF_VERSION "6.20.0") # handled by release scripts
 set(KF_DEP_VERSION "6.19.0") # handled by release scripts
 project(KWallet VERSION ${KF_VERSION})
 set(CMAKE_EXPORT_COMPILE_COMMANDS 1)

=== debian/changelog ===
kf6-kwallet (6.19.0+p24.04+vstable+git20251015.1052-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Wed, 15 Oct 2025 10:52:24 +0000

## kf6-kwallet 6.19.0+p24.04+vstable+git20251021.0600

=== CMakeLists.txt ===
--- 
+++ 
@@ -19,7 +19,7 @@
 include(KDEGitCommitHooks)
 include(ECMDeprecationSettings)
 
-set(REQUIRED_QT_VERSION 6.7.0)
+set(REQUIRED_QT_VERSION 6.8.0)
 find_package(Qt6 ${REQUIRED_QT_VERSION} CONFIG REQUIRED Core DBus Gui Widgets)
 
 include(ECMGenerateExportHeader)

=== debian/changelog ===
kf6-kwallet (6.19.0+p24.04+vstable+git20251021.0600-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Tue, 21 Oct 2025 06:00:55 +0000

=== debian/control ===
Source: kf6-kwallet
Section: libs
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               doxygen,
               graphviz,
               kde-qdoc-common-dev,
               kf6-extra-cmake-modules,
               kf6-kcolorscheme-dev,
               kf6-kconfig-dev,
               kf6-kconfigwidgets-dev,
               kf6-kcoreaddons-dev,
               kf6-kcrash-dev,
               kf6-kdbusaddons-dev,
               kf6-kdoctools-dev,
               kf6-ki18n-dev,
               kf6-kiconthemes-dev,
               kf6-knotifications-dev,
               kf6-kservice-dev,
               kf6-kwidgetsaddons-dev,
               kf6-kwindowsystem-dev,
               libboost-dev,
               libgcrypt20-dev,
               libgpgme-dev,
               libgpgmepp-dev,
               libqca-qt6-dev,
               libsecret-1-dev,
               pkg-kde-tools-neon,
               qt6-base-dev,
               qt6-tools-dev
Standards-Version: 4.6.2
Homepage: https://projects.kde.org/projects/frameworks/kwallet
Vcs-Git: https://invent.kde.org/neon/kf6/kf6-kwallet.git
Vcs-Browser: https://invent.kde.org/neon/kf6/kf6-kwallet
Maintainer: Neon CI <neon@kde.org>

Package: kf6-kwallet
Architecture: any
Section: kde
X-Neon-MergedPackage: true
Depends: libqca-qt6-plugins, libsecret-1-0, ${misc:Depends}, ${shlibs:Depends}
Breaks: libkf5wallet-bin (<< 5.115.0-1)
Replaces: libkf5wallet-bin (<< 5.115.0-1),
          libkf6wallet-bin,
          libkf6wallet-data,
          libkf6wallet6,
          libkwalletbackend6-6
Description: Secure and unified container for user passwords.
 Runtime for interface to KWallet, the safe desktop-wide storage
 for passwords on KDE workspaces.
 .
 Contains the runtime files for kwallet-framework

Package: kf6-kwallet-dev
Architecture: any
Section: kde
X-Neon-MergedPackage: true
Depends: kf6-kwallet (= ${binary:Version}),
         qt6-base-dev,
         ${misc:Depends},
         ${shlibs:Depends}
Replaces: libkf6wallet-dev, libkf6wallet-doc
Description: development files for kwallet-framework
 Interface to KWallet, the safe desktop-wide storage
 for passwords on KDE workspaces.
 .
 Contains development files for kwallet-framework.

Package: libkf6wallet6
Architecture: all
Depends: kf6-kwallet, ${misc:Depends}
Description: Dummy transitional
 Transitional dummy package.

Package: libkwalletbackend6-6
Architecture: all
Depends: kf6-kwallet, ${misc:Depends}
Description: Dummy transitional
 Transitional dummy package.

Package: libkf6wallet-bin
Architecture: all
Depends: kf6-kwallet, ${misc:Depends}
Description: Dummy transitional
 Transitional dummy package.

Package: libkf6wallet-data
Architecture: all
Depends: kf6-kwallet, ${misc:Depends}
Description: Dummy transitional
 Transitional dummy package.

Package: libkf6wallet-dev
Architecture: all
Depends: kf6-kwallet-dev, ${misc:Depends}
Description: Dummy transitional
 Transitional dummy package.

Package: libkf6wallet-doc
Architecture: all
Depends: kf6-kwallet-dev, ${misc:Depends}
Description: Dummy transitional
 Transitional dummy package.

## kf6-kwallet 6.19.0+p24.04+vunstable+git20251020.0324

=== debian/changelog ===
kf6-kwallet (6.19.0+p24.04+vunstable+git20251020.0324-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Mon, 20 Oct 2025 03:24:09 +0000
